#include <IOKit/pci/IOPCIDevice.h>
#include "mapMemoryDriver.h"
#include <IOKit/IOLib.h>
#include <IOKit/assert.h>


#define super IOService

OSDefineMetaClassAndStructors( driver_MapMemory, IOService )


bool MapMemoryDriver::start( IOService* provider )
{
	IOLog("%s[%p]::%s(%p)\n", getName(), this, __FUNCTION__, provider);
	requireRoot = true;
    if (!super::start( provider )) return false;
		
    assert( OSDynamicCast( IOPCIDevice, provider ));
    fPCIDevice = (IOPCIDevice *) provider;
 	OSBoolean *prop_root = OSDynamicCast(OSBoolean, copyProperty(kMyRootKey));
	if (prop_root) requireRoot = prop_root->getValue();

    registerService();
    return (copyGlobalMemory()!=NULL);
}


void MapMemoryDriver::stop( IOService* provider )
{
	IOLog("%s[%p]::%s(%p)\n", getName(), this, __FUNCTION__, provider);
    super::stop( provider );
}


IOMemoryDescriptor * MapMemoryDriver::copyGlobalMemory( void )
{
	IOLog("%s[%p]::%s()\n", getName(), this, __FUNCTION__);
    IOMemoryDescriptor* memory;    
    memory = fPCIDevice->getDeviceMemoryWithRegister( kIOPCIConfigBaseAddress0 );
    if( memory)
        memory->retain();
    return memory;
}