#include "mapMemoryDriverUserClient.h"
#include <IOKit/IOLib.h>
#include <IOKit/IOKitKeys.h>
#include <IOKit/assert.h>
#include <IOKit/pci/IOPCIDevice.h>

#define super IOUserClient

OSDefineMetaClassAndStructors(driver_MapMemoryUserClient, IOUserClient);

bool MapMemoryDriverUserClient::start(IOService* provider)
{
	IOLog("%s[%p]::%s(provider = %p)\n", getName(), this, __FUNCTION__, provider);
    if (!super::start(provider)) return false;
	
	isRoot = clientHasPrivilege(current_task(), kIOClientPrivilegeAdministrator )==kIOReturnSuccess;
    assert(OSDynamicCast(MapMemoryDriver, provider));
    fDriver = (MapMemoryDriver*) provider;
	
    return true;
}


IOReturn MapMemoryDriverUserClient::clientClose(void)
{
	IOLog("%s[%p]::%s()\n", getName(), this, __FUNCTION__);
	if( !isInactive()) terminate();	
    return kIOReturnSuccess;
}


void MapMemoryDriverUserClient::stop(IOService* provider)
{
	IOLog("%s[%p]::%s(provider = %p)\n", getName(), this, __FUNCTION__, provider);
    super::stop(provider);
}


IOReturn MapMemoryDriverUserClient::clientMemoryForType(UInt32 type,
														IOOptionBits* options,
														IOMemoryDescriptor** memory )
{
	IOLog("%s[%p]::%s()\n", getName(), this, __FUNCTION__);
	
	if (isRoot or !fDriver->getRequireRoot()) {
		*memory  = fDriver->copyGlobalMemory();
		return kIOReturnSuccess;
	} else {
		return kIOReturnError;
	}
}
